/*
 * Checkbox
 *
 * For accessibility, we provide a style for focus only on Tab,
 * for that add the javascript polyfill for focus-visible
 * (https://github.com/WICG/focus-visible).
 *
 * Index
 * - Checkbox
 * - Label
 * - Error
 * - Helper
 * - Position
 */


/* CHECKBOX
 -------------------- */

:host {
  position: relative;
  display: block;
  margin-bottom: 1.5rem;
  font-family: var(--road-font, sans-serif);
  font-size: var(--road-font-size-16);
  line-height: 1.5;
  color: var(--road-on-surface);
}

/**
 * Hide input
 */

.form-check-input {
  position: absolute;
  z-index: -1;
  opacity: 0;
}

/* LABEL
 -------------------- */

.form-check-label {
  position: relative;
  display: inline-flex;
  margin: 0;
  cursor: pointer;
  -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
}

.form-check-label::before {
  box-sizing: border-box;
  display: block;
  flex-shrink: 0;
  width: 1.25rem;
  height: 1.25rem;
  margin: 0 0.75rem 0 0;
  content: "";
  background: var(--road-surface);
  border: 1px solid var(--road-input-outline);
  border-radius: 0.25rem;
  transition: border 0.2s ease-in-out, background 0.2s ease-in-out;
}

.form-check-label-span {
  color: var(--road-on-surface-weak);
}

.form-check-icon {
  position: absolute;
  top: 0;
  left: 0;
  box-sizing: border-box;
  display: block;
  width: 1.25rem;
  height: 1.25rem;
  color: var(--road-primary-contrast);
  opacity: 0;
  transition: opacity 0.2s ease-in-out;
}

/**
 * Hover state
 */

@media (hover: hover) {

  .form-check-input:not(:disabled) ~ .form-check-label:hover::before {
    border-color: var(--road-input-surface-variant);
  }

  .form-check-input:not(:disabled):checked ~ .form-check-label:hover::before,
  .form-check-input:not(:disabled):indeterminate ~ .form-check-label:hover::before {
    background: var(--road-input-surface-variant);
  }
}

/**
 * Checked state
 */

.form-check-input:checked ~ .form-check-label .form-check-icon,
.form-check-input:indeterminate ~ .form-check-label .form-check-icon {
  opacity: 1;
}

.form-check-input:checked ~ .form-check-label::before,
.form-check-input:indeterminate ~ .form-check-label::before {
  background: var(--road-input-surface);
  border-color: var(--road-input-surface);
}

/**
 * Focus on Tab
 */

.form-check-input.focus-visible ~ .form-check-label::before {
  box-shadow: 0 0 0 0.125rem var(--road-grey-000), 0 0 0 0.1875rem var(--road-primary-700);
}

.form-check-input.focus-visible:checked ~ .form-check-label::before,
.form-check-input.focus-visible:indeterminate ~ .form-check-label::before {
  background: var(--road-input-surface-variant);
  border-color: var(--road-input-surface-variant);
}

/**
 * Disabled state
 */

.form-check-input:disabled ~ .form-check-label,
.form-check-input[readonly] ~ .form-check-label {
  cursor: not-allowed;
}

.form-check-input:disabled ~ .form-check-label::before,
.form-check-input[readonly] ~ .form-check-label::before {
  background: var(--road-surface-disabled);
  border: none;
}

.form-check-input:disabled ~ .form-check-label .form-check-icon,
.form-check-input[readonly] ~ .form-check-label .form-check-icon {
  fill: var(--road-on-surface-disabled);
}

/* ERROR
 -------------------- */

.invalid-feedback {
  display: none;
  flex: 0 0 100%;
  width: 100%;
  margin-top: 0.5rem;
  font-size: var(--road-font-size-12);
  color: var(--road-danger-default);
}

.form-check-input.is-invalid ~ .form-check-label::before,
.was-validated .form-check-input:invalid ~ .form-check-label::before {
  border-color: var(--road-danger-outline);
}

.form-check-input.is-invalid ~ .invalid-feedback,
.was-validated .form-check-input:invalid ~ .invalid-feedback {
  display: block;
}

/* POSITION
 -------------------- */

.form-checkbox-inverse {
  display: flex;
  flex-direction: row-reverse;
  justify-content: space-between;
}

.form-checkbox-inverse::before {
  margin: 0 0 0 1rem;
}

.form-checkbox-inverse .form-check-icon {
  right: 0;
  left: auto;
}

/* HELPER
 -------------------- */

.helper {
  margin-top: 0.5rem;
  margin-left: 2rem;
  font-size: var(--road-font-size-14);
  color: var(--road-on-surface-weak);
}
